<?php
add_hook("InvoicePaid",1,function($vars){
    $invoiceid = $vars["invoiceid"];
    $result = localAPI("GetInvoice",["invoiceid" => $invoiceid]);
    if($result["result"] == "success"){
        $firstitem = $result["items"]["item"][0];
        if(strpos($firstitem["description"],"KEYDIY") !== false){
            $userid = $result["userid"];
            $subtotal = $result["subtotal"];
            $relid = $firstitem["relid"];
            $result = select_query("tblhosting","tblhosting.*,tblproducts.servertype",["tblhosting.id" => $relid],"","","","tblproducts ON tblproducts.id = tblhosting.packageid");
            $service_data = mysql_fetch_array($result);
            $module = $service_data["servertype"];
            update_query("tblhosting",["amount" => $service_data["amount"]+$subtotal],["id" => $relid]);
            $serverModule = new WHMCS\Module\Server();
            $serverModule->setServiceId($service_data["id"]);
            $serverModule->load($module);
            $moduleParams = $serverModule->buildParams();
            if(!class_exists("beDiyoApi")){
                require __DIR__."/be_system.php";
            }
            $api = new beDiyoApi();
            $api->beSetServer([
                "name" => $moduleParams["serverhostname"],
                "username" => $moduleParams["serverusername"],
                "password" => $moduleParams["serverpassword"],
                "access_hash" => $moduleParams["serveraccesshash"]
            ]);
            preg_match('/KEYDIY \| (.*?) (.*?) (.*?) Yükseltmesi/i',$firstitem["description"],$itemdata);
            $count = (int)$itemdata[1];
            switch($itemdata[3]){
                case "CPU" :
                    $response = $api->beUpdateVM([
                        "vm_id" => $moduleParams["customfields"]["vm_id"],
                        "updatetype" => "upgrade",
                        "cpuCore" => $count
                    ]);
                    if(!$response["status"]){
                        logActivity("Kullanıcının sahip olduğu ürünün({$relid}) yükseltme işlemi(CPU - {$count}) başarısız oldu",$userid);
                        logModuleCall($module,"Sunucu CPU yüseltme işlemi başarısız oldu!","",$response);
                    }
                    else{
                        logActivity("Kullanıcının sahip olduğu ürünün({$relid}) yükseltme işlemi(CPU - {$count}) başarılı oldu",$userid);
                    }
                    break;
                case "RAM" :
                    $response = $api->beUpdateVM([
                        "vm_id" => $moduleParams["customfields"]["vm_id"],
                        "updatetype" => "upgrade",
                        "ramGB" => $count
                    ]);
                    if(!$response["status"]){
                        logActivity("Kullanıcının sahip olduğu ürünün({$relid}) yükseltme işlemi(RAM - {$count}) başarısız oldu",$userid);
                        logModuleCall($module,"Sunucu RAM yüseltme işlemi başarısız oldu!","",$response);
                    }
                    else{
                        logActivity("Kullanıcının sahip olduğu ürünün({$relid}) yükseltme işlemi(RAM - {$count}) başarılı oldu",$userid);
                    }
                    break;
                case "DISK" :
                    $response = $api->beUpdateVM([
                        "vm_id" => $moduleParams["customfields"]["vm_id"],
                        "updatetype" => "upgrade",
                        "diskGB" => $count
                    ]);
                    if(!$response["status"]){
                        logActivity("Kullanıcının sahip olduğu ürünün({$relid}) yükseltme işlemi(DISK - {$count}) başarısız oldu",$userid);
                        logModuleCall($module,"Sunucu DISK yüseltme işlemi başarısız oldu!","",$response);
                    }
                    else{
                        logActivity("Kullanıcının sahip olduğu ürünün({$relid}) yükseltme işlemi(DISK - {$count}) başarılı oldu",$userid);
                    }
                    break;
            }
        }
    }
});